''' <summary>
'''  Zeichenflche, auf der DrawCircle-Objekte dargestellt werden
''' </summary>
Public Class Canvas : Inherits Control

    <Disposable()> Private _DrawCircles As New DisposeList(Of DrawCircle)

    Protected Overrides Sub OnMouseClick(ByVal e As MouseEventArgs)
        ' Entfernt einen DrawCircle oder setzt einen neuen 
        MyBase.OnMouseClick(e)

        Dim dc As DrawCircle
        For Each dc In _DrawCircles
            If dc.Contains(e.Location) Then
                ' Neuzeichnen an dc's Position anfordern, dc entfernen, 
                '  Methode verlassen
                Me.Invalidate(dc.Bounds)
                _DrawCircles.Remove(dc)
                Return
            End If
        Next
        ' Neuen DrawCircle erzeugen, positionieren, _DrawCircles zufgen, 
        '  Neuzeichnen anfordern
        dc = New DrawCircle(30, Color.Red, 8)
        dc.Location = e.Location
        _DrawCircles.Add(dc)
        Me.Invalidate(dc.Bounds)
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        MyBase.OnPaint(e)
        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        For Each dc As DrawCircle In _DrawCircles
            dc.Draw(e.Graphics)
        Next
    End Sub

    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        ' Da Canvas nicht von DisposableBase erben kann, muss 
        '  DisposableAttribute.DisposeFields() explizit aufgerufen werden.
        '  Anstatt attributgesteuerten Disposens knnte man einfach 
        '  _DrawObjects.Clear() aufrufen. Aber wenn weitere disposable Klassen-
        '  Member hinzukommen...
        If disposing Then DisposableAttribute.DisposeFields(Me)
        MyBase.Dispose(disposing)
    End Sub

End Class
