Imports System.ComponentModel
Public Class DisposableBase : Implements IDisposable

    Private disposedValue As Boolean = False
    Private Shared _MyType As Type

    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If _MyType Is Nothing Then _MyType = Me.GetType
        If Me.disposedValue Then Return
        If disposing Then DisposableAttribute.DisposeFields(_MyType, Me)
        Me.disposedValue = True
    End Sub

    Public Sub Dispose() Implements IDisposable.Dispose
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overrides Sub Finalize()
        Dispose(False)
        MyBase.Finalize()
    End Sub

End Class

