Imports System.Drawing
Imports System.Drawing.Drawing2D

Public Class DrawCircle : Inherits DisposableBase

    <Disposable()> Private _TemplatePath As New GraphicsPath
    <Disposable()> Private _DrawPath As New GraphicsPath
    <Disposable()> Private _Brush As SolidBrush
    <Disposable()> Private _Mtr As New Matrix

    Private _Location As Point
    Private _Bounds As Rectangle

    Public Sub New(ByVal radius As Single, ByVal color As Color, _
        ByVal penWidth As Single)

        _Brush = New SolidBrush(color)
        _TemplatePath.AddEllipse(-radius, -radius, 2 * radius, 2 * radius)
    End Sub

    Public Sub Draw(ByVal g As Graphics)
        g.FillPath(_Brush, _DrawPath)
    End Sub

    Public ReadOnly Property Contains(ByVal pt As Point) As Boolean
        Get
            Return _DrawPath.IsVisible(pt)
        End Get
    End Property

    Public Property Location() As Point
        Get
            Return _Location
        End Get
        Set(ByVal value As Point)
            _Location = value
            _DrawPath.Reset()
            _DrawPath.AddPath(_TemplatePath, False)
            _Mtr.Reset()
            _Mtr.Translate(Location.X, Location.Y, MatrixOrder.Append)
            _DrawPath.Transform(_Mtr)
            _Bounds = Rectangle.Round(_DrawPath.GetBounds)
            ' Bei Zeichnen mit AntiAliasing knnen "Glttungspunkte" ausserhalb 
            '  der eigentlichen Bounds liegen. Daher Bounds etwas grer fassen.
            _Bounds.Inflate(1, 1)
        End Set
    End Property

    ''' <summary> Das diese Figur umschlieene Rechteck </summary>
    Public ReadOnly Property Bounds() As Rectangle
        Get
            Return _Bounds
        End Get
    End Property

End Class